Index: WebKit/gtk/webkit/webkitevent.cpp
===================================================================
--- WebKit/gtk/webkit/webkitevent.cpp	(revision 0)
+++ WebKit/gtk/webkit/webkitevent.cpp	(revision 0)
@@ -0,0 +1,260 @@
+/*
+ * Copyright (C) 2007 Holger Hans Peter Freyther
+ * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
+ *
+ * This library is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU Library General Public
+ * License as published by the Free Software Foundation; either
+ * version 2 of the License, or (at your option) any later version.
+ *
+ * This library is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * Library General Public License for more details.
+ *
+ * You should have received a copy of the GNU Library General Public License
+ * along with this library; see the file COPYING.LIB.  If not, write to
+ * the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
+ * Boston, MA 02110-1301, USA.
+ */
+
+#include "config.h"
+
+#include "Event.h"
+#include "Event.h"
+#include "CString.h"
+#include "StringImpl.h"
+
+
+#include "config.h"
+#include "HTMLDocument.h"
+
+
+#include "DocumentLoader.h"
+#include "Element.h"
+#include "EventListener.h"
+#include "EventNames.h"
+#include "FrameLoader.h"
+#include "FrameView.h"
+#include "HTMLNames.h"
+#include "Settings.h"
+#include "Node.h"
+#include "XMLHttpRequest.h"
+#include "Frame.h"
+#include "EventListenerXMLHttpRequest.h"
+#include "EventListenerWindow.h"
+#include "EventListenerNode.h"
+#include "EventTargetNode.h"
+#include "HTMLDocument.h"
+#include "CString.h"
+#include "StringImpl.h"
+#include "GdomEvent.h"
+#include "GDOMObject.h"
+#include "PrivateGdomDOMObject.h"
+#include "webkitevent.h"
+#include "PrivateGdomEventTargetNode.h"
+#include "GdomXMLHttpRequest.h"
+#include "PrivateGdomXMLHttpRequest.h"
+
+
+#include <glib-object.h>
+
+
+using namespace WebCore;
+
+namespace WebCore {
+    gpointer toGDOM(Event* doc);
+    gpointer toGDOM(EventTargetNode* node);
+    gpointer toGDOM(XMLHttpRequest* node);
+}
+
+extern "C" {
+
+G_DEFINE_TYPE(WebKitEvent, webkit_event, G_TYPE_OBJECT);
+
+struct _WebKitEventPrivate {
+    Event* event;
+};
+
+#define WEBKIT_EVENT_GET_PRIVATE(obj) (G_TYPE_INSTANCE_GET_PRIVATE((obj), WEBKIT_TYPE_EVENT, WebKitEventPrivate))
+
+static void webkit_event_finalize(GObject* object)
+{
+    //WebKitEvent* request = WEBKIT_EVENT(object);
+    //WebKitEventPrivate* priv = request->priv;
+
+    //g_free(priv->uri);
+
+    G_OBJECT_CLASS(webkit_event_parent_class)->finalize(object);
+}
+
+static void webkit_event_class_init(WebKitEventClass* requestClass)
+{
+    G_OBJECT_CLASS(requestClass)->finalize = webkit_event_finalize;
+
+    g_type_class_add_private(requestClass, sizeof(WebKitEventPrivate));
+}
+
+static void webkit_event_init(WebKitEvent* request)
+{
+    WebKitEventPrivate* priv = WEBKIT_EVENT_GET_PRIVATE(request);
+    request->priv = priv;
+}
+
+WebKitEvent* webkit_event_new(void)
+{
+    WebKitEvent* request = WEBKIT_EVENT(g_object_new(WEBKIT_TYPE_EVENT, NULL));
+    //priv->event = event;
+
+    return request;
+}
+
+/*
+void webkit_event_set_uri(WebKitEvent* request, const gchar* uri)
+{
+    g_return_if_fail(WEBKIT_IS_EVENT(request));
+    g_return_if_fail(uri);
+
+    WebKitEventPrivate* priv = request->priv;
+
+    g_free(priv->uri);
+    priv->uri = g_strdup(uri);
+}
+*/
+G_CONST_RETURN gchar* webkit_event_get_event_type(WebKitEvent* request)
+{
+    g_return_val_if_fail(WEBKIT_IS_EVENT(request), NULL);
+
+    WebKitEventPrivate* priv = request->priv;
+    return g_strdup(priv->event->type().string().utf8().data());
+}
+
+void webkit_event_cancel_bubble  (WebKitEvent *request, gboolean cancel)
+{
+    WebKitEventPrivate* priv = request->priv;
+    priv->event->setCancelBubble(cancel);
+}
+
+void webkit_event_prevent_default  (WebKitEvent *request)
+{
+    WebKitEventPrivate* priv = request->priv;
+    priv->event->preventDefault();
+}
+
+void webkit_event_stop_propagation  (WebKitEvent *request)
+{
+    WebKitEventPrivate* priv = request->priv;
+    priv->event->stopPropagation();
+}
+
+WEBKIT_API gboolean
+add_window_event_listener(WebKitWebFrame* wf, Frame *frame, const char *name);
+
+} // extern "C"
+
+class XMLHttpRequestEventListener : public EventListener {
+public:
+    static PassRefPtr<XMLHttpRequestEventListener> create(GdomXMLHttpRequest* wf)
+    { return adoptRef(new XMLHttpRequestEventListener(wf)); }
+    virtual void handleEvent(Event*, bool useCapture);
+
+    private:
+    XMLHttpRequestEventListener(GdomXMLHttpRequest* wf) : m_wf(wf) { }
+    GdomXMLHttpRequest* m_wf;
+};
+
+void XMLHttpRequestEventListener::handleEvent(Event* event, bool useCapture)
+{
+    gboolean retval;
+    /* TODO: see JSEventListener.cpp's handleEvent - some weird stuff... */
+    printf("XMLHttpRequest handleEvent %s\n", event->type().string().utf8().data());
+    GdomEvent *wev = GDOM_EVENT(WebCore::toGDOM(event));
+    g_signal_emit_by_name(m_wf, "browser-event", wev, useCapture, &retval);
+}
+
+class NodeEventListener : public EventListener {
+public:
+    static PassRefPtr<NodeEventListener> create(GdomEventTargetNode* wf)
+    { return adoptRef(new NodeEventListener(wf)); }
+    virtual void handleEvent(Event*, bool useCapture);
+
+    private:
+    NodeEventListener(GdomEventTargetNode* wf) : m_wf(wf) { }
+    GdomEventTargetNode* m_wf;
+};
+
+void NodeEventListener::handleEvent(Event* event, bool useCapture)
+{
+    gboolean retval;
+    printf("node handleEvent %s\n", event->type().string().utf8().data());
+    GdomEvent *wev = GDOM_EVENT(WebCore::toGDOM(event));
+    g_signal_emit_by_name(m_wf, "browser-event", wev, useCapture, &retval);
+}
+
+class WindowEventListener : public EventListener {
+public:
+    static PassRefPtr<WindowEventListener> create(WebKitWebFrame* wf) 
+    { return adoptRef(new WindowEventListener(wf)); }
+    virtual void handleEvent(Event*, bool isWindowEvent);
+
+    private:
+    WindowEventListener(WebKitWebFrame* wf) : m_wf(wf) { }
+    WebKitWebFrame* m_wf;
+};
+
+void WindowEventListener::handleEvent(Event* event, bool isWindowEvent)
+{
+    gboolean retval;
+    printf("window handleEvent %s\n", event->type().string().utf8().data());
+    GdomEvent *wev = GDOM_EVENT(WebCore::toGDOM(event));
+    g_signal_emit_by_name(m_wf, "browser-event", wev, isWindowEvent, &retval);
+}
+
+gboolean add_xml_http_request_event_listener(GdomXMLHttpRequest *wf,
+                            const char *name)
+{
+    WebCore::XMLHttpRequest *req = gdom_xml_http_request_get_private(wf);
+    if (name == NULL)
+        return FALSE;
+    if (req == NULL)
+        return FALSE;
+
+    if (strcmp(name, "onreadystatechange") == 0)
+    {
+        RefPtr<XMLHttpRequestEventListener> listener;
+        listener = XMLHttpRequestEventListener::create(wf);
+        req->setOnReadyStateChangeListener(listener);
+        return TRUE;
+    }
+    return FALSE;
+} 
+
+gboolean add_event_listener(GdomEventTargetNode *wf, const char *name,
+                            gboolean useCapture)
+{
+    WebCore::Node *node = gdom_event_target_node_get_private(wf);
+    if (node == NULL || !node->isEventTargetNode())
+        return FALSE;
+    WebCore::EventTargetNode * etn = (static_cast<WebCore::EventTargetNode *>(node))->toNode();
+    if (etn == NULL)
+        return FALSE;
+
+    RefPtr<NodeEventListener> listener = NodeEventListener::create(wf);
+    etn->addEventListener(name, listener, useCapture);
+
+    return TRUE;
+
+} 
+
+gboolean add_window_event_listener(WebKitWebFrame *wf, Frame *frame,
+                                   const char *name)
+{
+    Document* doc = frame->document();
+
+    RefPtr<WindowEventListener> listener = WindowEventListener::create(wf);
+    doc->addWindowEventListener(name, listener, true);
+
+    return TRUE;
+
+} 
+
Index: WebKit/gtk/webkit/webkitdefines.h
===================================================================
--- WebKit/gtk/webkit/webkitdefines.h	(revision 35758)
+++ WebKit/gtk/webkit/webkitdefines.h	(working copy)
@@ -40,6 +40,9 @@
 
 G_BEGIN_DECLS
 
+typedef struct _WebKitEvent WebKitEvent;
+typedef struct _WebKitEventClass WebKitEventClass;
+
 typedef struct _WebKitNetworkRequest WebKitNetworkRequest;
 typedef struct _WebKitNetworkRequestClass WebKitNetworkRequestClass;
 
